%macro add_date(data , k = 12); 
proc sql ; 
create table dates as select distinct
rdate , date from (select distinct rdate from &data) a, crsp.msi b
where 0<= intck('month',rdate,date)<&k order by rdate , date ; 
proc sql ; 
create table &data(drop = rdate rename = (date = rdate)) as select distinct
a.* , b.date from &data a , dates b where a.rdate = b.rdate ; 
drop table dates ; 
quit ; 
%mend ; 


