%macro Figure1;

proc reg data = temp.p10_bm noprint outest = b; by ind growth; model xret = mkt ; run ;
data b_all; set b;  where ind ne 11; ind2 = 
'bm______'    ; run;
proc delete data = b ; run ;

proc reg data = temp.p10_op noprint outest = b; by ind growth; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'op'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = temp.p10_inv noprint outest = b; by ind growth; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'inv'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = temp.p10_beta noprint outest = b; by ind growth; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'beta'   ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = temp.p10_pay noprint outest = b; by ind growth; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'pay'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = temp.p10_IV  noprint outest = b; where intck('month', rdate, date)=1; by ind growth; model xret = mkt  ; run ;
data b; set b; where ind ne 11; ind2 = 
'IV'   ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc sort data = b_all ; by ind2;run;

data Figure1; set b_all; run;

proc delete data = b_all;run;

%mend;




proc sql; create table aa as select distinct
a.*, b.growth_rebalance as growth
from ind.p10_portfolios a, ind.div_char_all b where a.ind=b.ind and a.ind2=b.name and a.ex="USA";

proc reg data = aa noprint outest = b; by ind growth; where ind2 = 
'bm_____'    ;  model xret = mkt ; run ;
data b_all; set b;  where ind ne 11; ind2 = 'bm_____'    ; run;
proc delete data = b ; run ;

proc reg data = aa noprint outest = b; by ind growth; where ind2 = 
'op_'    ; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'op_'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = aa noprint outest = b; by ind growth; where ind2 = 
'inv_'    ;  model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'inv_'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = aa noprint outest = b; by ind growth; where ind2 = 
'beta_'   ;model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'beta_'   ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = aa noprint outest = b; by ind growth; where ind2 = 
'PAY_'    ; model xret = mkt ; run ;
data b; set b; where ind ne 11; ind2 = 
'PAY_'    ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;

proc reg data = aa  noprint outest = b; where ind2 = 
'IV_'   ; by ind growth; model xret = mkt  ; run ;
data b; set b; where ind ne 11; ind2 = 
'IV_'   ; run;
proc append data = b base = b_all ;run; proc delete data = b ; run ;
